---
title: The MDN Content Kitchensink
slug: MDN/Kitchensink
tags:
  - Kitchensink
  - MDN Meta
---
<div>{{MDNSidebar}}</div>

<p>The <b>kitchensink</b> is an <i>attempt</i> to incorporate every possible content element and every Yari macros possible.</p>

<h2>About this page</h2>

<p>This page attempts to be the complete intersection of every other page. No in terms of the text but in terms of the
styles and macros. Let's start with some notes...</p>

<p>Text that uses the <code>&lt;kbd&gt;</code> tag: <kbd>Shift</kbd></p>

<div class="notecard note">
  <h4>Note</h4>
  <p>Here's a block indicator note.</p>
</div>

<div class="notecard warning">
  <h4>Warning</h4>
  <p>Here's a block indicator warning.</p>
</div>

<h2>Prev/Next buttons</h2>

<p>{{PreviousMenuNext("Games/Techniques/Control_mechanisms/Desktop_with_mouse_and_keyboard", "Games/Techniques/Control_mechanisms/Other", "Games/Techniques/Control_mechanisms")}}</p>

<h3>Another one...</h3>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Extra_lives", "Games/Workflows/2D_Breakout_game_Phaser/Buttons")}}</p>

<h2>Code snippets</h2>

<h3>Plain text</h3>
<pre>
  ___________________________
&lt; I'm an expert in my field. &gt;
  ---------------------------
         \   ^__^
          \  (oo)\_______
             (__)\       )\/\
                 ||----w |
                 ||     ||
</pre>

<h3>HTML</h3>

<pre class="brush: html">&lt;pre&gt;
</pre>

<h3>JavaScript</h3>

<pre class="brush: js">const f = () =&gt; {
  return Math.random();
}
</pre>

<h3>CSS</h3>

<pre class="brush: css">
:root {
  --first-color: #488cff;
  --second-color: #ffff8c;
}

#firstParagraph {
  background-color: var(--first-color);
  color: var(--second-color);
}
</pre>

<h3>WebAssembly</h3>

<pre class="brush: wasm">(func (param i32) (param f32) (local f64)
  local.get 0
  local.get 1
  local.get 2)</pre>

<h3>Rust</h3>

<pre class="brush: rust; notranslate">#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        assert_eq!(2 + 2, 4);
    }
}</pre>

<h3>Python</h3>

<pre class="brush: python">class BookListView(generic.ListView):
    model = Book
    # your own name for the list as a template variable
    context_object_name = 'my_book_list'
    queryset = Book.objects.filter(title__icontains='war')[:5]
    template_name = 'books/my_arbitrary_template_name_list.html'
</pre>

<h3 id="Formal_syntax">Formal syntax</h3>

<p><em>The formal syntax must be taken from the spec and added to the <a href="https://github.com/mdn/data">MDN data repository</a>. It is an important tool to get precise syntax information for advanced users.</em></p>

<pre class="syntaxbox">{{CSSSyntax}}</pre>

<h2>Interactive Examples</h2>

<div>{{EmbedInteractiveExample("pages/tabbed/abbr.html", "tabbed-shorter")}}</div>

<div>{{EmbedInteractiveExample("pages/css/order.html")}}</div>

<div>{{EmbedInteractiveExample("pages/js/regexp-assertions.html", "taller")}}</div>

<h2>Tables</h2>

<table class="standard-table">
  <thead>
   <tr>
    <th scope="col">Specification</th>
    <th scope="col">Status</th>
    <th scope="col">Comment</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td>{{SpecName("HTML WHATWG", "#link-type-dns-prefetch", "dns-prefetch")}}</td>
    <td>{{Spec2("HTML WHATWG")}}</td>
    <td></td>
   </tr>
  </tbody>
 </table>

 <table class="properties">
  <tbody>
   <tr>
    <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
    <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>, palpable content.</td>
   </tr>
   <tr>
    <th scope="row">Permitted content</th>
    <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">Phrasing content</a>.</td>
   </tr>
   <tr>
    <th scope="row">Tag omission</th>
    <td>{{no_tag_omission}}</td>
   </tr>
   <tr>
    <th scope="row">Permitted parents</th>
    <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
   </tr>
   <tr>
    <th scope="row">Implicit ARIA role</th>
    <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
   </tr>
   <tr>
    <th scope="row">Permitted ARIA roles</th>
    <td>Any</td>
   </tr>
   <tr>
    <th scope="row">DOM interface</th>
    <td>{{domxref("HTMLElement")}}</td>
   </tr>
  </tbody>
 </table>

<table class="fullwidth-table">
<caption>Values for the content of <code>&lt;meta name="viewport"&gt;</code></caption>
<thead>
  <tr>
  <th scope="col">Value</th>
  <th scope="col">Possible subvalues</th>
  <th scope="col">Description</th>
  </tr>
</thead>
<tbody>
  <tr>
  <td><code>width</code></td>
  <td>A positive integer number, or the text <code>device-width</code></td>
  <td>Defines the pixel width of the viewport that you want the web site to be rendered at.</td>
  </tr>
  <tr>
  <td><code>user-scalable</code>  {{ReadOnlyInline}}</td>
  <td><code>yes</code> or <code>no</code></td>
  <td>If set to <code>no</code>, the user is not able to zoom in the webpage. The default is <code>yes</code>. Browser settings can ignore this rule, and iOS10+ ignores it by default.</td>
  </tr>
  <tr>
  <td><code>viewport-fit</code></td>
  <td><code>auto</code>, <code>contain</code> or <code>cover</code></td>
  <td>
    <p>The <code>auto</code> value doesn’t affect the initial layout viewport, and the whole web page is viewable.</p>

    <p>The <code>contain</code> value means that the viewport is scaled to fit the largest rectangle inscribed within the display.</p>

    <p>The <code>cover</code> value means that the viewport is scaled to fill the device display. It is highly recommended to make use of the <a href="/en-US/docs/Web/CSS/env">safe area inset</a> variables to ensure that important content doesn't end up outside the display.</p>
  </td>
  </tr>
  <tr>
    <td>{{SpecName('Fetch','#forbidden-response-header-name','forbidden-response-header-name')}}</td>
    <td>{{spec2('Fetch')}}</td>
    <td> </td>
   </tr>
</tbody>
</table>

<h2>Every macro under the sun</h2>

<p><strong>Well, almost every macro. Hopefully only the ones that are in active use.</strong></p>

<p>An {{Glossary("HTTP")}} error code meaning "Bad Gateway".</p>
<p>A {{Glossary("Server", "server")}} can act as a gateway or proxy (go-between) between a client (like your Web browser) and another, upstream server. When you request to access a {{Glossary("URL")}}, the gateway server can relay your request to the upstream server. "502" means that the upstream server has returned an invalid response.</p>

<ul>
<li>JavaScript {{jsxref("Array")}} on MDN</li>
</ul>

<p>Listening for mouse movement is even easier than listening for key
  presses: all we need is the listener for the {{event("mousemove")}} event.
  ...just below the <code>keyup event</code>:
</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("html.elements.video")}}</div>

<h2 id="Axis-Aligned_Bounding_Box">Axis-Aligned Bounding Box</h2>

<p>One of the simpler forms of collision detection is between two rectangles that are axis aligned — meaning no rotation. The algorithm works by ensuring there is no gap between any of the 4 sides of the rectangles. Any gap means a collision does not exist.</p>

<pre class="brush: js">var rect1 = {x: 5, y: 5, width: 50, height: 50}
var rect2 = {x: 20, y: 10, width: 10, height: 10}

if (rect1.x &lt; rect2.x + rect2.width &amp;&amp;
   rect1.x + rect1.width &gt; rect2.x &amp;&amp;
   rect1.y &lt; rect2.y + rect2.height &amp;&amp;
   rect1.y + rect1.height &gt; rect2.y) {
    // collision detected!
}

// filling in the values =&gt;

if (5 &lt; 30 &amp;&amp;
    55 &gt; 20 &amp;&amp;
    5 &lt; 20 &amp;&amp;
    55 &gt; 10) {
    // collision detected!
}
</pre>

<div class="hidden">
<h5 id="Rect_code">Rect code</h5>

<pre class="brush: html">&lt;div id="cr-stage"&gt;&lt;/div&gt;
&lt;p&gt;Move the rectangle with arrow keys. Green means collision, blue means no collision.&lt;/p&gt;
&lt;script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/crafty/0.5.4/crafty-min.js"&gt;&lt;/script&gt;
</pre>

<pre class="brush: js">Crafty.init(200, 200);

var dim1 = {x: 5, y: 5, w: 50, h: 50}
var dim2 = {x: 20, y: 10, w: 60, h: 40}

var rect1 = Crafty.e("2D, Canvas, Color").attr(dim1).color("red");

var rect2 = Crafty.e("2D, Canvas, Color, Keyboard, Fourway").fourway(2).attr(dim2).color("blue");

rect2.bind("EnterFrame", function () {
    if (rect1.x &lt; rect2.x + rect2.w &amp;&amp;
        rect1.x + rect1.w &gt; rect2.x &amp;&amp;
        rect1.y &lt; rect2.y + rect2.h &amp;&amp;
        rect1.h + rect1.y &gt; rect2.y) {
        // collision detected!
        this.color("green");
    } else {
        // no collision
        this.color("blue");
    }
});

</pre>
</div>

<p>{{ EmbedLiveSample('Rect_code', '700', '300', '', 'Games/Techniques/2D_collision_detection') }}</p>

<p>{{APIRef("Web Animations")}}{{SeeCompatTable}}</p>

<h3 id="Obsolete_CSSOM_interfaces">Obsolete CSSOM interfaces {{Obsolete_Inline}}</h3>

<p>{{Obsolete_Header}}</p>

<p>{{InheritanceDiagram}}</p>

<div>{{EmbedGHLiveSample("web-tech-games/index.html", '100%', 820)}}</div>

<ul>
  <li><a href="/en-US/docs/Web/Accessibility">Accessibility resources at MDN</a></li>
  <li>{{Interwiki("wikipedia", "Web accessibility")}} on Wikipedia</li>
</ul>

<p>The {{TemplateLink("AvailableInWorkers")}} macro inserts a localised note box indicating that a feature is available in a <a href="/en-US/docs/Web/API/Web_Workers_API">Web worker</a> context.</p>

<p>{{AvailableInWorkers}}</p>

<ul>
  <li>{{ARIARole("button")}}</li>
  <li>{{ARIARole("checkbox")}}</li>
  <li>{{ARIARole("menuitem")}}</li>
  <li>{{ARIARole("menuitemcheckbox")}}</li>
  <li>{{ARIARole("menuitemradio")}}</li>
  <li>{{ARIARole("option")}}</li>
  <li>{{ARIARole("radio")}}</li>
  <li>{{ARIARole("switch")}}</li>
  <li>{{ARIARole("tab")}}</li>
  <li>{{ARIARole("treeitem")}}</li>
 </ul>

 <ul>
  <li>Create a {{htmlelement("canvas")}} element and set its <code>width</code> and <code>height</code> attributes to the original, smaller resolution.</li>
  <li>Set its CSS {{cssxref("width")}} and {{cssxref("height")}} properties to be 2x or 4x the value of the HTML <code>width</code> and <code>height</code>. If the canvas was created with a 128 pixel width, for example, we would set the CSS <code>width</code> to <code>512px</code> if we wanted a 4x scale.</li>
  <li>Set the {{htmlelement("canvas")}} element's <code>image-rendering</code> CSS property to some value that does not make the image blurry. Either <code>crisp-edges</code> or <code>pixelated</code> will work. Check out the {{cssxref("image-rendering")}} article for more information on the differences between these values, and which prefixes to use depending on the browser.</li>
 </ul>

<ul>
  <li><a href="/en-US/docs/Glossary">MDN Web Docs Glossary</a>:

  <ul>
    <li>{{Glossary("XHR_(XMLHttpRequest)","XMLHttpRequest")}}</li>
  </ul>
  </li>
  <li>{{interwiki("wikipedia", "AJAX")}} on Wikipedia</li>
  <li><a href="/en-US/docs/Web/Guide/AJAX">Ajax</a></li>
  <li><a href="/en-US/docs/Web/Guide/AJAX/Getting_Started">Ajax - Getting started</a></li>
  <li>{{DOMxRef("XMLHttpRequest")}}</li>
  <li>{{DOMxRef("Fetch API")}}</li>
  <li><a href="/en-US/docs/Web/API/Fetch_API/Using_Fetch">Using Fetch API</a></li>
  <li><a href="http://peoplesofttutorial.com/difference-between-synchronous-and-asynchronous-messaging/">Synchronous vs. Asynchronous Communications</a></li>
</ul>

<ul>
  <li>{{SVGElement("feGaussianBlur")}}</li>
  <li>{{SVGAttr("keySplines")}} SVG attribute</li>

  <li>{{htmlattrxref("dir")}}</li>
  <li>{{htmlattrxref("lang")}}</li>
  <li>{{cssxref(":dir")}}</li>
  <li>{{cssxref("direction")}}</li>
</ul>

<h2 id="Types">Types</h2>

<dl>
 <dt>{{WebExtAPIRef("alarms.Alarm")}}</dt>
 <dd>Information about a particular alarm.</dd>
</dl>

{{Non-standard_Header}}
{{Obsolete_Header}}
{{Deprecated_Header}}
